// compile: gcc -Wall Inheritance-CSoln.c -o Inheritance-CSoln

#include <stdio.h>

typedef struct {
  float x;
} Base;

void Base_init  (Base *const this, const float x) { this->x = x; }
void Base_deinit(Base *const this)                { }

void Base_print(const Base *const this) { printf("%g\n",this->x); }


typedef struct {
  Base base;
  float y;
} Derived;

void Derived_init(Derived *const this, const float x,const float y) {
  Base_init(&this->base, x);
  this->y = y;
}
void Derived_deinit(Derived *const this) { Base_deinit(&this->base); }

void Derived_print(const Derived *const this) {
  Base_print(&this->base);
  printf("%g\n",this->y);
}


int main() {
  Derived x;  Derived_init(&x, 1.0,2.0);
  Base *y = &x.base;

  printf("Printing x:\n");
  Derived_print(&x);
  printf("Printing x through y:\n");
  Base_print(y);

  return 0;
}
